/**
	\file
	\brief Contains Exception methods.
*/




#include "exception.h"
#include "helpers.h"

#include <sstream>




/*==============================================================================
	Exception methods
==============================================================================*/


Exception::Exception( char const* const file, unsigned int const line, std::string const& what ) {

	std::stringstream stream;
	stream << file << " - line " << line << std::endl << '\t' << CollapseWhitespace( what );
	m_what = stream.str();
}


Exception::Exception( char const* const file, unsigned int const line, std::string const& what, char const* const message ) {

	std::stringstream stream;
	stream << file << " - line " << line << std::endl << '\t' << CollapseWhitespace( what ) << std::endl << '\t' << CollapseWhitespace( message );
	m_what = stream.str();
}


Exception::~Exception() throw() {
}


const char* Exception::what() const throw() {

	return m_what.c_str();
}
