#pragma once

#ifndef RENDERER_DETAIL_NORMAL_MRF_HELPERS_H
#define RENDERER_DETAIL_NORMAL_MRF_HELPERS_H




#include "vector.h"

#include <algorithm>




namespace Renderer {


namespace detail {




/*==============================================================================
	SolveCardinal helper function
==============================================================================*/


void SolveCardinal(
	float const* const depths,
	std::pair< double, Vector< double, 2 > >* const states,
	Vector< unsigned int, 2 > const& dimension,
	Vector< unsigned int, 2 > const& coordinates,
	unsigned int const size,
	double const scale,
	double const spread,
	double const voxelSize,
	double const observationPrecision,
	double const gradientPrecision,
	double const minimumEdgeDelta,
	double const maximumEdgeDelta
);




/*==============================================================================
	SolveDiagonal helper function
==============================================================================*/


void SolveDiagonal(
	float const* const depths,
	std::pair< double, Vector< double, 2 > >* const states,
	Vector< unsigned int, 2 > const& dimension,
	Vector< unsigned int, 2 > const& coordinates,
	unsigned int const size,
	double const scale,
	double const spread,
	double const voxelSize,
	double const observationPrecision,
	double const gradientPrecision,
	double const minimumEdgeDelta,
	double const maximumEdgeDelta
);




}    // namespace detail


}    // namespace Renderer




#endif    // RENDERER_DETAIL_NORMAL_MRF_HELPERS_H
